pub mod lua;
pub mod discord;
pub mod stdin;
pub mod echo;
pub mod random;
pub mod pvn;
pub mod echobox;
pub mod autolink;
pub mod logger;

pub mod loader;

use Tenquestionmarks;
use event::Envelope;

use std::sync::Arc;
use std::sync::mpsc::Receiver;
use transformable_channels::mpsc::ExtSender;

use toml::Table;

pub struct Module {
    event_loop: Box<EventLoop>,
    module_type: String,
    pub config: Table
}

impl Module {
    pub fn run (&self, sender: Box<ExtSender<Envelope>>, receiver: Receiver<Arc<Envelope>>) {
        self.event_loop.run(sender, receiver);
    }
}

pub trait EventLoop : Sync {
    fn run (&self, _: Box<ExtSender<Envelope>>, _: Receiver<Arc<Envelope>>) {}
}
